package org.polymodel.x10p.util

import java.util.List
import org.polymodel.algebra.affine.AffineExpression
import org.polymodel.x10p.Assignment
import org.polymodel.Domain
import org.polymodel.x10p.Statement

import static extension org.polymodel.x10p.util.XtendUnparserUtils.*

class XtendX10pStatementWithTimeStamp extends XtendX10pStatementUnparser {
	
	override dispatch CharSequence unparse(Assignment a) '''
		//«a.timestamp.print»: «a.domain»
		«a.write.print» = «a.name»(«a.reads.join(', ', [r|r.print])»);
	'''
	
	def private print(List<AffineExpression> timestamp) {
		timestamp.join('[', ',', ']', [e|e.print]);
	}
	
}